package jeu;

import jeu.*;
import java.awt.Color;
/**
 * <code>PieceVide</code> est une implémentation de l'interface
 * <code>Piece</code> représentant une case vide.
 *
 * @author Pierre.Courtieu at univ-orleans.fr
 * @author Jeremy.Briffaut at ensi-bourges.fr
 * @version 1.0
 */
public class PieceVide implements Piece {

    public PieceVide() {
    }
    public java.awt.Color[][] getIcon(java.awt.Color fond) {
        java.awt.Color[][] t = new java.awt.Color[1][1];
        t[0][0] = fond;
        return t;
    }

    public Character getName() {
        return ' ';
    }

    /* SOLUTION:// Suggestion: implémenter equals et peut-être toString. */
    @Override
    public boolean equals(Object o) {
        // self check
        if (this == o) {
            return true;
        }
        // null check
        if (o == null) {
            return false;
        }
        // type check and cast
        if (getClass() != o.getClass()) {
            return false;
        }
        PieceVide c = (PieceVide) o;
        // field comparison
        return this.getName() == c.getName();
    }
    /* FIN SOLUTION */

}

