/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jeu.morpion;

import jeu.*;

/**
 * Le jeu de morpion.
 * @author courtieu
 */
public class Morpion {

    /* SOLUTION:// Suggestion: définir des fonctions auxiliaire, par exemple
    // testVictoire, coupValide, etc. */
    // Retourne true si la case c peut être jouée dans le plateau p
    private static boolean coupValide(Coordonnees c, Plateau p) {
        return(p.getPiece(c).getName() == ' ');
    }

    // Coche la case c avec la piece p dans le plateau p. Il faut tester
    // avant si le coup est permis (voir couValide).
    private static void joueCase(Coordonnees c,Piece piece, Plateau p) {
        p.setPiece(c, piece);
    }

    /**
     * Teste si le plateau p contient une situation de victoire d'un joueur.
     * 
     * @param p le plateau à tester
     * @return NullPointer Exception si une case est null
     */
    private static boolean testVictoire(Plateau p) {

        // Teste toutes les lignes et diagonales et colonnes.
        // Pour le puissance 4 on essaiera de faire plus malin car trop long.
        // Par exemple en ne testant que les alignements *contenant le dernier coup*.
        // Ici il est inutile de faire compliqué:
        Coordonnees hg = new Coordonnees(0, 0);
        Coordonnees mg = hg.b(); // début de la ligne 2
        Coordonnees bg = mg.b(); // début de la ligne 3
        Coordonnees hm = hg.d(); // début de la colonne 2
        Coordonnees hd = hm.d(); // début de la colonne 3
        // On pourrait stocker ces coordonnées qqpart pour éviter de les
        // recalculer à chaque fois. Dans un tableau 8x3 par exemple
        return (false
                || testligne(hg , hg.b() , hg.b().b() , p)  // colonne 1
                || testligne(hm , hm.b() , hm.b().b() , p)  // colonne 2
                || testligne(hd , hd.b() , hd.b().b() , p)  // colonne 3

                || testligne(hg , hg.d() , hg.d().d() , p)  // ligne 1
                || testligne(mg , mg.d() , mg.d().d() , p)  // ligne 2
                || testligne(bg , bg.d() , bg.d().d() , p)  // ligne 3
                
                || testligne(hg , hg.bd() , hg.bd().bd() , p)// diag hgbd
                || testligne(bg , bg.hd() , bg.hd().hd() , p)// diag bdhg
                );
    }

    /**
     * teste si les 3 coordonnées contiennent la même pièce non vide dans le plateau p.
     * @param c, c1 et c3 les coordonnées 
     * @param p le plateau
     * @return un booléen.
     */
    private static boolean testligne(Coordonnees c, Coordonnees c1, Coordonnees c2, Plateau p) {
        // On utilise la méthode equals redéfinie dans chaque classe de pièce.
        // on aurait aussi pu comparer les getName() directement.
        return (p.getPiece(c).equals(p.getPiece(c1))
              && p.getPiece(c).equals(p.getPiece(c2))
              && ! (p.getPiece(c).equals(new PieceVide())) 
                
                );
    }

    /* FIN SOLUTION */

    public static void main(String arg[]) {
        int largeur=3;
        Plateau plateau = new Plateau(largeur,largeur);
        // Si vous l'avez implémentée vou pouvez utiliser l'interface textuele.
        //IOTextePlateau plateau = new IOTextePlateau();
        IOGraphiquePlateau igp = new IOGraphiquePlateau(plateau);
        // Initialisation du damier
        for (int i = 0; i < largeur; i = i + 1) {
            for (int j = 0; j < largeur; j = j + 1) {
                plateau.setPiece(i, j, new PieceVide());
            }
        }
        /* SOLUTION:
        // Une petite boucle qui montre l'effet de getCoup()
        while(true){
            Coordonnees c = igp.getCoup("Choisissez une case?");
            System.out.println("Vous avez cliquez la case: " + c.getX() + "," + c.getY());
        }*/
        int k = 0; // numéro du joueur qui joue
        int nbTours = 0; // nb total de tour joués
        boolean fini = false; // la partie est-elle finie?
        int gagnant = -1; // qui a gagné? -1 signifie personne
        while(!fini){
            // Afficher le damier et attendre le coup joué.
            Coordonnees c = igp.getCoup("joueur "+k+" choisissez une case?");
            // debug: System.out.println("Vous avez cliquez la case: " + c.getX() + "," + c.getY());
            if (coupValide(c,plateau)) { // si le coup est valide, on l'effecute
                nbTours = nbTours+1;
                Piece coche;
                if (k==0) { coche = new Croix(); } else { coche = new Rond(); }
                joueCase(c,coche,plateau);
                k = 1 - k; // 0 <-> 1
                // est-ce fini par victoire?
                if (testVictoire(plateau)) {
                    fini = true;
                    gagnant = k;
                } // Ou bien par match nul?
                else if (nbTours >= largeur*largeur) {
                    fini = true;
                    gagnant = -1;
                }
            } // si le coup n'est pas valide, on ne fait rien, juste un message.
            else {
                System.out.println("*** Coup interdit! Rejouez.");
            }
        }
        // On est sorti, pour nul ou vistoire?
        if (gagnant == -1) System.out.println("Partie nulle");
        else System.out.println("joueur "+gagnant+ " a gagné");
        igp.getCoup("Fin de partie.");
        /* FIN SOLUTION */
    }
}
